image = imread('Testimages/classify/image1.png');

% The timestamps for each image. If searching through many images,
% the list of images should be accompanied by a list of timestamps which
% can be loaded into matlab
times = [1377071735; 1377156379];
resolution = 50; % 50 x 50 meters per pixel

% Make grayscale
if size(image,3)==3
    image = rgb2gray(image);
end

% Find dimensions
[rows,cols] = size(image);
y = 1:rows;
x = 1:cols;

% Making the image into a binary matrix

 % The added constant is used if we only want targets which are distinctly
 % more/less bright than the remaining targets
constant = 100;
[image_o,T] = binaryMatrix3(image,constant);


% Image processing
image_o = imageproc(image_o,0);


% Find and store properties
[centroids1,properties1] = satcharacterize(image_o);

detection = zeros(size(centroids1,1),1);
%imshow(image_o);
image1=image_o;
