% Load image
%prompt = 'Name of the initial image (Ex: "image1.png") : ';
%image = imread(input(prompt));
image = imread('Testimages/track/image1.png'); % The first image must always be called this


% Make grayscale
if size(image,3)==3
    image = rgb2gray(image);
end

% Find dimensions
[rows,cols] = size(image);
y = 1:rows;
x = 1:cols;

% Making the image into a binary matrix
[image_o,T] = binaryMatrix2(image);
%[image_o] = binaryMatrix(image);

% Image processing
%image_o = imageproc(image_o,0);
image_o = imageprocsat(image,image_o,1,T);

% Find and store properties
[centroids1,properties1] = satcharacterize(image_o);

detection = zeros(size(centroids1,1),1);

image1=image_o;
