dynamic_model;

disp('Running Simulation...');
sim('drift_model');

save('drift_model_last_run.mat');

figure;
hold on;
t = xOut.Time;
colordef white

% Plotting the results in nort-south direction
subplot 321, plot(t, xOut.Data(:,1),'r'), xlabel('time, t [s]'), ylabel('position x [m/s]');
subplot 322, plot(t, xOut.Data(:,3),'r'), xlabel('time, t [s]'), ylabel('velocity u [m/s]');
subplot 323, plot(t, xOut.Data(:,5),'r'), xlabel('time, t [s]'), ylabel('air velocity a [m/s]');
subplot 324, plot(t, xOut.Data(:,7),'r'), xlabel('time, t [s]'), ylabel('current velocity c [m/s]');
subplot 325, plot(t, xOut.Data(:,9),'r'), xlabel('time, t [s]'), ylabel('wave velocity w [m/s]');
