dynamic_model;

disp('Running Simulation...');
sim('drift_model_kalman_intermittent');

save('drift_model_kalman_intermittent_last_run.mat');

figure;
hold on;
t = xOut.Time;
colordef white

% Error plot (uhat-u)
%plot(t, xHatOut.Data(:,3)-xOut.Data(:,3), 'b'), legend 'u' 'uHat', xlabel('t [s]'), ylabel('e [m/s]');

% Estimation versus model plot
hold on ,plot(t, xOut.Data(:,3),'r'), plot(t, xHatOut.Data(:,3), 'b'), legend 'u' 'uHat', xlabel('t [s]'), ylabel('u [m/s]');
