#ifndef __c1_drift_model_kalman_intermittent_h__
#define __c1_drift_model_kalman_intermittent_h__

/* Include files */
#include "sf_runtime/sfc_sf.h"
#include "sf_runtime/sfc_mex.h"
#include "rtwtypes.h"
#include "multiword_types.h"

/* Type Definitions */
#ifndef typedef_SFc1_drift_model_kalman_intermittentInstanceStruct
#define typedef_SFc1_drift_model_kalman_intermittentInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c1_sfEvent;
  boolean_T c1_isStable;
  boolean_T c1_doneDoubleBufferReInit;
  uint8_T c1_is_active_c1_drift_model_kalman_intermittent;
  real_T c1_P[100];
  boolean_T c1_P_not_empty;
  real_T c1_xhat[10];
  boolean_T c1_xhat_not_empty;
  real_T c1_Q[100];
  boolean_T c1_Q_not_empty;
  real_T c1_R[64];
  boolean_T c1_R_not_empty;
  real_T c1_B[60];
  boolean_T c1_B_not_empty;
} SFc1_drift_model_kalman_intermittentInstanceStruct;

#endif                                 /*typedef_SFc1_drift_model_kalman_intermittentInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c1_drift_model_kalman_intermittent_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c1_drift_model_kalman_intermittent_get_check_sum(mxArray *plhs[]);
extern void c1_drift_model_kalman_intermittent_method_dispatcher(SimStruct *S,
  int_T method, void *data);

#endif
