dynamic_model;

disp('Running Simulation...');
sim('drift_model_kalman');

save('drift_model_kalman_last_run.mat');

figure;
hold on;
t = xOut.Time;
colordef white


% Plot of the states in north-south direction
subplot 321, hold on, plot(t, xOut.Data(:,1),'r'), plot(t, xHatOut.Data(:,1), 'b'), legend 'x' 'xHat';
subplot 322, hold on, plot(t, xOut.Data(:,3),'r'), plot(t, xHatOut.Data(:,3), 'b'), legend 'u' 'uHat';
subplot 323, hold on, plot(t, xOut.Data(:,5),'r'), plot(t, xHatOut.Data(:,5), 'b'), legend 'a' 'aHat';
subplot 324, hold on, plot(t, xOut.Data(:,7),'r'), plot(t, xHatOut.Data(:,7), 'b'), legend 'c' 'cHat';
subplot 325, hold on, plot(t, xOut.Data(:,9),'r'), plot(t, xHatOut.Data(:,9), 'b'),legend 'w' 'wHat';