function image_o = imageproc(image_o,trig)
    
    % Filling holes%
    image_o= imfill(image_o, 'hole');

    % Find the cluster sizes
    [clust,numb] = bwlabel(image_o, 8);
    area = regionprops(clust,'Area');
    cluster_size =  hist(clust(:),0:numb);
    cluster_size = cluster_size(2:end);   %Array representing the icefloe areas
    maxclust = max(cluster_size); % Area of the biggest ice floe.
    
    % Extract the largest element
    %ind = find([area.Area] >= maxclust-500);
    %ind = find([area.Area] >= 1500);
    %Iout = ismember(clust,ind);
    %image_o = Iout;
    
    if trig
        % Erode if many connecting floes
        image_o = erosion(image_o,1);


        % Morphology - closing and opening
    %     R=30;
    %     se = strel('octagon',R);
    %     image_o = imclose(image_o, se);
    %     image_o = imopen(image_o, se);
    end
end