%--- Parameters ---%

rho_si = 900; % Sea ice density, [km/m^3]

V_a = 4.45; % Wind velocity. Average weather data from the region
theta_a=190/180*pi;    %Vind direction South-West

H_s = 2; % Significant wave height, which is the average height of the 1/3 highest waves in a sea state
a = 0.5*H_s; % Wave amplitude

%V_res = 0.01; % The residual current
%V_tc = 0.02; % The tidal current
%V_w = V_res + V_tc; % Current velocity.
V_w = 0.125; % The East Greenland current
theta_c=190/180*pi;   %Current direction
